## cpufetch 0.98

=== Makefile ===
CC ?= gcc

CFLAGS+=-Wall -Wextra -pedantic -fstack-protector-all -pedantic -std=c99
SANITY_FLAGS=-Wfloat-equal -Wshadow -Wpointer-arith

PREFIX ?= /usr

SRC_COMMON=src/common/

COMMON_SRC = $(SRC_COMMON)main.c $(SRC_COMMON)cpu.c $(SRC_COMMON)udev.c $(SRC_COMMON)printer.c $(SRC_COMMON)args.c $(SRC_COMMON)global.c
COMMON_HDR = $(SRC_COMMON)ascii.h $(SRC_COMMON)cpu.h $(SRC_COMMON)udev.h $(SRC_COMMON)printer.h $(SRC_COMMON)args.h $(SRC_COMMON)global.h

ifneq ($(OS),Windows_NT)
	arch := $(shell uname -m)
	ifeq ($(arch), $(filter $(arch), x86_64 i686))
		SRC_DIR=src/x86/
		SOURCE += $(COMMON_SRC) $(SRC_DIR)cpuid.c $(SRC_DIR)apic.c $(SRC_DIR)cpuid_asm.c $(SRC_DIR)uarch.c
		HEADERS += $(COMMON_HDR) $(SRC_DIR)cpuid.h $(SRC_DIR)apic.h $(SRC_DIR)cpuid_asm.h $(SRC_DIR)uarch.h
		CFLAGS += -DARCH_X86
	else
		SRC_DIR=src/arm/
		SOURCE += $(COMMON_SRC) $(SRC_DIR)midr.c $(SRC_DIR)uarch.c $(SRC_DIR)soc.c $(SRC_DIR)udev.c
		HEADERS += $(COMMON_HDR) $(SRC_DIR)midr.h $(SRC_DIR)uarch.h  $(SRC_DIR)soc.h $(SRC_DIR)udev.c $(SRC_DIR)socs.h
		CFLAGS += -DARCH_ARM -Wno-unused-parameter
	endif

	OUTPUT=cpufetch
else
	# Assume x86_64
	SRC_DIR=src/x86/
	SOURCE += $(COMMON_SRC) $(SRC_DIR)cpuid.c $(SRC_DIR)apic.c $(SRC_DIR)cpuid_asm.c $(SRC_DIR)uarch.c
	HEADERS += $(COMMON_HDR) $(SRC_DIR)cpuid.h $(SRC_DIR)apic.h $(SRC_DIR)cpuid_asm.h $(SRC_DIR)uarch.h
	CFLAGS += -DARCH_X86
	SANITY_FLAGS += -Wno-pedantic-ms-format
	OUTPUT=cpufetch.exe
endif

all: CFLAGS += -O3
all: $(OUTPUT)

debug: CFLAGS += -g -O0
debug: $(OUTPUT)

static: CFLAGS += -static -O3
static: $(OUTPUT)

$(OUTPUT): Makefile $(SOURCE) $(HEADERS)
	$(CC) $(CFLAGS) $(SANITY_FLAGS) $(SOURCE) -o $(OUTPUT)

run: $(OUTPUT)
	./$(OUTPUT)

clean:
	@rm -f $(OUTPUT)

install: $(OUTPUT)
	install -Dm755 "cpufetch"   "$(DESTDIR)$(PREFIX)/bin/cpufetch"
	install -Dm644 "LICENSE"    "$(DESTDIR)$(PREFIX)/share/licenses/cpufetch-git/LICENSE"
	install -Dm644 "cpufetch.1" "$(DESTDIR)$(PREFIX)/share/man/man1/cpufetch.1.gz"

uninstall:
	rm -f "$(DESTDIR)$(PREFIX)/bin/cpufetch"
	rm -f "$(DESTDIR)$(PREFIX)/share/licenses/cpufetch-git/LICENSE"
	rm -f "$(DESTDIR)$(PREFIX)/share/man/man1/cpufetch.1.gz"

## cpufetch 1.0+git20211101+a5b321a9668f

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 CC ?= gcc
 
-CFLAGS+=-Wall -Wextra -pedantic -fstack-protector-all -pedantic -std=c99
+CFLAGS+=-Wall -Wextra -pedantic
 SANITY_FLAGS=-Wfloat-equal -Wshadow -Wpointer-arith
 
 PREFIX ?= /usr
@@ -12,16 +12,38 @@
 
 ifneq ($(OS),Windows_NT)
 	arch := $(shell uname -m)
-	ifeq ($(arch), $(filter $(arch), x86_64 i686))
+	ifeq ($(arch), $(filter $(arch), x86_64 amd64 i686))
 		SRC_DIR=src/x86/
 		SOURCE += $(COMMON_SRC) $(SRC_DIR)cpuid.c $(SRC_DIR)apic.c $(SRC_DIR)cpuid_asm.c $(SRC_DIR)uarch.c
 		HEADERS += $(COMMON_HDR) $(SRC_DIR)cpuid.h $(SRC_DIR)apic.h $(SRC_DIR)cpuid_asm.h $(SRC_DIR)uarch.h
-		CFLAGS += -DARCH_X86
-	else
+
+                os := $(shell uname -s)
+                ifeq ($(os), Linux)
+			SOURCE += freq.o
+			CFLAGS += -pthread
+                endif
+		CFLAGS += -DARCH_X86 -std=c99 -fstack-protector-all
+	else ifeq ($(arch), $(filter $(arch), ppc64le ppc64 ppcle ppc))
+		SRC_DIR=src/ppc/
+		SOURCE += $(COMMON_SRC) $(SRC_DIR)ppc.c $(SRC_DIR)uarch.c $(SRC_DIR)udev.c
+		HEADERS += $(COMMON_HDR) $(SRC_DIR)ppc.h $(SRC_DIR)uarch.h  $(SRC_DIR)udev.c
+		CFLAGS += -DARCH_PPC -std=gnu99 -fstack-protector-all
+	else ifeq ($(arch), $(filter $(arch), arm aarch64_be aarch64 arm64 armv8b armv8l armv7l armv6l))
 		SRC_DIR=src/arm/
 		SOURCE += $(COMMON_SRC) $(SRC_DIR)midr.c $(SRC_DIR)uarch.c $(SRC_DIR)soc.c $(SRC_DIR)udev.c
 		HEADERS += $(COMMON_HDR) $(SRC_DIR)midr.h $(SRC_DIR)uarch.h  $(SRC_DIR)soc.h $(SRC_DIR)udev.c $(SRC_DIR)socs.h
-		CFLAGS += -DARCH_ARM -Wno-unused-parameter
+		CFLAGS += -DARCH_ARM -Wno-unused-parameter -std=c99 -fstack-protector-all
+
+		os := $(shell uname -s)
+		ifeq ($(os), Darwin)
+			SOURCE += $(SRC_DIR)sysctl.c
+			HEADERS += $(SRC_DIR)sysctl.h
+		endif
+	else
+		# Error lines should not be tabulated because Makefile complains about it
+$(warning Unsupported arch detected: $(arch). See https://github.com/Dr-Noob/cpufetch#1-support)
+$(warning If your architecture is supported but the compilation fails, please open an issue in https://github.com/Dr-Noob/cpufetch/issues)
+$(error Aborting compilation)
 	endif
 
 	OUTPUT=cpufetch
@@ -30,19 +52,25 @@
 	SRC_DIR=src/x86/
 	SOURCE += $(COMMON_SRC) $(SRC_DIR)cpuid.c $(SRC_DIR)apic.c $(SRC_DIR)cpuid_asm.c $(SRC_DIR)uarch.c
 	HEADERS += $(COMMON_HDR) $(SRC_DIR)cpuid.h $(SRC_DIR)apic.h $(SRC_DIR)cpuid_asm.h $(SRC_DIR)uarch.h
-	CFLAGS += -DARCH_X86
+	CFLAGS += -DARCH_X86 -std=c99
 	SANITY_FLAGS += -Wno-pedantic-ms-format
 	OUTPUT=cpufetch.exe
 endif
 
-all: CFLAGS += -O3
+all: CFLAGS += -O2
 all: $(OUTPUT)
 
 debug: CFLAGS += -g -O0
 debug: $(OUTPUT)
 
-static: CFLAGS += -static -O3
+static: CFLAGS += -static -O2
 static: $(OUTPUT)
+
+strict: CFLAGS += -O2 -Werror -fsanitize=undefined -D_FORTIFY_SOURCE=2
+strict: $(OUTPUT)
+
+freq.o: Makefile $(SRC_DIR)freq.c $(SRC_DIR)freq.h
+	$(CC) $(CFLAGS) $(SANITY_FLAGS) -c -mavx -mfma -pthread $(SRC_DIR)freq.c -o freq.o
 
 $(OUTPUT): Makefile $(SOURCE) $(HEADERS)
 	$(CC) $(CFLAGS) $(SANITY_FLAGS) $(SOURCE) -o $(OUTPUT)
@@ -51,7 +79,7 @@
 	./$(OUTPUT)
 
 clean:
-	@rm -f $(OUTPUT)
+	@rm -f $(OUTPUT) freq.o
 
 install: $(OUTPUT)
 	install -Dm755 "cpufetch"   "$(DESTDIR)$(PREFIX)/bin/cpufetch"

=== debian/changelog ===
cpufetch (1.0+git20211101+a5b321a9668f-3) unstable; urgency=medium

  * Upload to unstable.

 -- Clay Stan <claystan97@gmail.com>  Thu, 18 Nov 2021 17:45:52 +0800

cpufetch (1.0+git20211101+a5b321a9668f-2) experimental; urgency=medium

  * Fix the problematic patch.
  * Fix build failed on armel,armhf,arm64,ppc64,powerpc,ppc64el.

 -- Clay Stan <claystan97@gmail.com>  Thu, 18 Nov 2021 16:57:45 +0800

cpufetch (1.0+git20211101+a5b321a9668f-1) unstable; urgency=medium

  * Newest upstream commit a5b321a9668f.
  * Some known bugs may be fixed.
  * use_cc_dumpmachine (Closes: #999880).
  * bug 998722 fixed-upstream (Closes: 998722).

 -- Clay Stan <claystan97@gmail.com>  Thu, 18 Nov 2021 13:56:19 +0800

cpufetch (1.0-1) unstable; urgency=medium

  * New upstream version 1.0.
  * add support for powerpc, Apple M1.

 -- Clay Stan <claystan97@gmail.com>  Wed, 08 Sep 2021 14:10:49 +0800

cpufetch (0.98-1) unstable; urgency=medium

  * Initial release (Closes: #986783)

 -- Clay Stan <claystan97@gmail.com>  Mon, 12 Apr 2021 14:50:05 +0800

## cpufetch 1.01%2Bgit20211208%2B40b13bc

=== Makefile ===
--- 
+++ 
@@ -12,14 +12,15 @@
 
 ifneq ($(OS),Windows_NT)
 	arch := $(shell uname -m)
-	ifeq ($(arch), $(filter $(arch), x86_64 amd64 i686))
+	ifeq ($(arch), $(filter $(arch), x86_64 amd64 i386 i486 i586 i686))
 		SRC_DIR=src/x86/
 		SOURCE += $(COMMON_SRC) $(SRC_DIR)cpuid.c $(SRC_DIR)apic.c $(SRC_DIR)cpuid_asm.c $(SRC_DIR)uarch.c
-		HEADERS += $(COMMON_HDR) $(SRC_DIR)cpuid.h $(SRC_DIR)apic.h $(SRC_DIR)cpuid_asm.h $(SRC_DIR)uarch.h
+		HEADERS += $(COMMON_HDR) $(SRC_DIR)cpuid.h $(SRC_DIR)apic.h $(SRC_DIR)cpuid_asm.h $(SRC_DIR)uarch.h $(SRC_DIR)freq/freq.h
 
                 os := $(shell uname -s)
                 ifeq ($(os), Linux)
-			SOURCE += freq.o
+			SOURCE += $(SRC_DIR)freq/freq.c freq_nov.o freq_avx.o freq_avx512.o
+			HEADERS += $(SRC_DIR)freq/freq.h
 			CFLAGS += -pthread
                 endif
 		CFLAGS += -DARCH_X86 -std=c99 -fstack-protector-all
@@ -69,8 +70,14 @@
 strict: CFLAGS += -O2 -Werror -fsanitize=undefined -D_FORTIFY_SOURCE=2
 strict: $(OUTPUT)
 
-freq.o: Makefile $(SRC_DIR)freq.c $(SRC_DIR)freq.h
-	$(CC) $(CFLAGS) $(SANITY_FLAGS) -c -mavx -mfma -pthread $(SRC_DIR)freq.c -o freq.o
+freq_nov.o: Makefile $(SRC_DIR)freq/freq_nov.c $(SRC_DIR)freq/freq_nov.h
+	$(CC) $(CFLAGS) $(SANITY_FLAGS) -c -pthread $(SRC_DIR)freq/freq_nov.c -o $@
+
+freq_avx.o: Makefile $(SRC_DIR)freq/freq_avx.c $(SRC_DIR)freq/freq_avx.h
+	$(CC) $(CFLAGS) $(SANITY_FLAGS) -c -mavx -pthread $(SRC_DIR)freq/freq_avx.c -o $@
+
+freq_avx512.o: Makefile $(SRC_DIR)freq/freq_avx512.c $(SRC_DIR)freq/freq_avx512.h
+	$(CC) $(CFLAGS) $(SANITY_FLAGS) -c -mavx512f -pthread $(SRC_DIR)freq/freq_avx512.c -o $@
 
 $(OUTPUT): Makefile $(SOURCE) $(HEADERS)
 	$(CC) $(CFLAGS) $(SANITY_FLAGS) $(SOURCE) -o $(OUTPUT)
@@ -79,7 +86,7 @@
 	./$(OUTPUT)
 
 clean:
-	@rm -f $(OUTPUT) freq.o
+	@rm -f $(OUTPUT) *.o
 
 install: $(OUTPUT)
 	install -Dm755 "cpufetch"   "$(DESTDIR)$(PREFIX)/bin/cpufetch"

## cpufetch 1.01+git20211208+40b13bc

=== debian/changelog ===
cpufetch (1.01+git20211208+40b13bc-2) unstable; urgency=medium

  * Upload to unstable.

 -- Clay Stan <claystan97@gmail.com>  Tue, 21 Dec 2021 15:54:49 +0800

cpufetch (1.01+git20211208+40b13bc-1) unstable; urgency=medium

  * New upstream commit 40b13bc.

 -- Clay Stan <claystan97@gmail.com>  Tue, 21 Dec 2021 15:10:21 +0800

=== debian/control ===
Source: cpufetch
Section: utils
Priority: optional
Maintainer: Clay Stan <claystan97@gmail.com>
Build-Depends: debhelper-compat (= 13)
Standards-Version: 4.6.0.1
Homepage: https://github.com/Dr-Noob/cpufetch
Vcs-Browser: https://salsa.debian.org/claystan/cpufetch
Vcs-Git: https://salsa.debian.org/claystan/cpufetch.git
Rules-Requires-Root: no

Package: cpufetch
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Simple yet fancy CPU architecture fetching tool
 Shows CPU Information with CPU manufacturer Logo
 Cpufetch is a cross-platform and easy-to-use cpu information
 command line script that collects your cpu information
 and display it on the terminal next to an image

## cpufetch 1.01+git20220306+0ea0754

=== debian/changelog ===
cpufetch (1.01+git20220306+0ea0754-1) unstable; urgency=medium

  * d/copyright: Upstream copyright have been changed.
  * Upload to unstable.

 -- Clay Stan <claystan97@gmail.com>  Fri, 15 Apr 2022 11:30:03 +0800

## cpufetch 1.02

=== Makefile ===
--- 
+++ 
@@ -70,13 +70,13 @@
 strict: CFLAGS += -O2 -Werror -fsanitize=undefined -D_FORTIFY_SOURCE=2
 strict: $(OUTPUT)
 
-freq_nov.o: Makefile $(SRC_DIR)freq/freq_nov.c $(SRC_DIR)freq/freq_nov.h
+freq_nov.o: Makefile $(SRC_DIR)freq/freq_nov.c $(SRC_DIR)freq/freq_nov.h $(SRC_DIR)freq/freq.h
 	$(CC) $(CFLAGS) $(SANITY_FLAGS) -c -pthread $(SRC_DIR)freq/freq_nov.c -o $@
 
-freq_avx.o: Makefile $(SRC_DIR)freq/freq_avx.c $(SRC_DIR)freq/freq_avx.h
+freq_avx.o: Makefile $(SRC_DIR)freq/freq_avx.c $(SRC_DIR)freq/freq_avx.h $(SRC_DIR)freq/freq.h
 	$(CC) $(CFLAGS) $(SANITY_FLAGS) -c -mavx -pthread $(SRC_DIR)freq/freq_avx.c -o $@
 
-freq_avx512.o: Makefile $(SRC_DIR)freq/freq_avx512.c $(SRC_DIR)freq/freq_avx512.h
+freq_avx512.o: Makefile $(SRC_DIR)freq/freq_avx512.c $(SRC_DIR)freq/freq_avx512.h $(SRC_DIR)freq/freq.h
 	$(CC) $(CFLAGS) $(SANITY_FLAGS) -c -mavx512f -pthread $(SRC_DIR)freq/freq_avx512.c -o $@
 
 $(OUTPUT): Makefile $(SOURCE) $(HEADERS)

=== debian/changelog ===
cpufetch (1.02-1) unstable; urgency=medium

  * New upstream version 1.02.

 -- Clay Stan <claystan97@gmail.com>  Thu, 14 Jul 2022 09:51:53 +0800

## cpufetch 1.03

=== Makefile ===
--- 
+++ 
@@ -28,7 +28,7 @@
 		SRC_DIR=src/ppc/
 		SOURCE += $(COMMON_SRC) $(SRC_DIR)ppc.c $(SRC_DIR)uarch.c $(SRC_DIR)udev.c
 		HEADERS += $(COMMON_HDR) $(SRC_DIR)ppc.h $(SRC_DIR)uarch.h  $(SRC_DIR)udev.c
-		CFLAGS += -DARCH_PPC -std=gnu99 -fstack-protector-all
+		CFLAGS += -DARCH_PPC -std=gnu99 -fstack-protector-all -Wno-language-extension-token
 	else ifeq ($(arch), $(filter $(arch), arm aarch64_be aarch64 arm64 armv8b armv8l armv7l armv6l))
 		SRC_DIR=src/arm/
 		SOURCE += $(COMMON_SRC) $(SRC_DIR)midr.c $(SRC_DIR)uarch.c $(SRC_DIR)soc.c $(SRC_DIR)udev.c

=== debian/changelog ===
cpufetch (1.03-4) unstable; urgency=medium

  * fixed build on ppc.

 -- Clay Stan <claystan97@gmail.com>  Thu, 16 Mar 2023 13:47:04 +0800

cpufetch (1.03-3) unstable; urgency=medium

  * fix a typo(upstraeam)> upstream) in changelog 1.03-2

 -- Clay Stan <claystan97@gmail.com>  Wed, 08 Mar 2023 16:06:02 +0800

cpufetch (1.03-2) unstable; urgency=medium

  * fix a typo(upstarma -> upstraeam) in changelog 1.03-1.

 -- Clay Stan <claystan97@gmail.com>  Fri, 24 Feb 2023 03:45:13 +0800

cpufetch (1.03-1) unstable; urgency=medium

  * New upstraeam version 1.03.

 -- Clay Stan <claystan97@gmail.com>  Thu, 23 Feb 2023 17:14:15 +0800

## cpufetch 1.04

=== Makefile ===
--- 
+++ 
@@ -1,7 +1,7 @@
 CC ?= gcc
 
 CFLAGS+=-Wall -Wextra -pedantic
-SANITY_FLAGS=-Wfloat-equal -Wshadow -Wpointer-arith
+SANITY_FLAGS=-Wfloat-equal -Wshadow -Wpointer-arith -Wstrict-prototypes
 
 PREFIX ?= /usr
 
@@ -11,6 +11,7 @@
 COMMON_HDR = $(SRC_COMMON)ascii.h $(SRC_COMMON)cpu.h $(SRC_COMMON)udev.h $(SRC_COMMON)printer.h $(SRC_COMMON)args.h $(SRC_COMMON)global.h
 
 ifneq ($(OS),Windows_NT)
+	GIT_VERSION := "$(shell git describe --abbrev=4 --dirty --always --tags)"
 	arch := $(shell uname -m)
 	ifeq ($(arch), $(filter $(arch), x86_64 amd64 i386 i486 i586 i686))
 		SRC_DIR=src/x86/
@@ -31,8 +32,8 @@
 		CFLAGS += -DARCH_PPC -std=gnu99 -fstack-protector-all -Wno-language-extension-token
 	else ifeq ($(arch), $(filter $(arch), arm aarch64_be aarch64 arm64 armv8b armv8l armv7l armv6l))
 		SRC_DIR=src/arm/
-		SOURCE += $(COMMON_SRC) $(SRC_DIR)midr.c $(SRC_DIR)uarch.c $(SRC_DIR)soc.c $(SRC_DIR)udev.c
-		HEADERS += $(COMMON_HDR) $(SRC_DIR)midr.h $(SRC_DIR)uarch.h  $(SRC_DIR)soc.h $(SRC_DIR)udev.c $(SRC_DIR)socs.h
+		SOURCE += $(COMMON_SRC) $(SRC_DIR)midr.c $(SRC_DIR)uarch.c $(SRC_COMMON)soc.c $(SRC_DIR)soc.c $(SRC_DIR)udev.c
+		HEADERS += $(COMMON_HDR) $(SRC_DIR)midr.h $(SRC_DIR)uarch.h  $(SRC_COMMON)soc.h $(SRC_DIR)soc.h $(SRC_DIR)udev.c $(SRC_DIR)socs.h
 		CFLAGS += -DARCH_ARM -Wno-unused-parameter -std=c99 -fstack-protector-all
 
 		os := $(shell uname -s)
@@ -40,6 +41,11 @@
 			SOURCE += $(SRC_DIR)sysctl.c
 			HEADERS += $(SRC_DIR)sysctl.h
 		endif
+        else ifeq ($(arch), $(filter $(arch), riscv64 riscv32))
+                SRC_DIR=src/riscv/
+                SOURCE += $(COMMON_SRC) $(SRC_DIR)riscv.c $(SRC_DIR)uarch.c $(SRC_COMMON)soc.c $(SRC_DIR)soc.c $(SRC_DIR)udev.c
+                HEADERS += $(COMMON_HDR) $(SRC_DIR)riscv.h $(SRC_DIR)uarch.h $(SRC_COMMON)soc.h $(SRC_DIR)soc.h $(SRC_DIR)udev.h $(SRC_DIR)socs.h
+                CFLAGS += -DARCH_RISCV -Wno-unused-parameter -std=c99 -fstack-protector-all
 	else
 		# Error lines should not be tabulated because Makefile complains about it
 $(warning Unsupported arch detected: $(arch). See https://github.com/Dr-Noob/cpufetch#1-support)
@@ -50,6 +56,7 @@
 	OUTPUT=cpufetch
 else
 	# Assume x86_64
+	GIT_VERSION := ""
 	SRC_DIR=src/x86/
 	SOURCE += $(COMMON_SRC) $(SRC_DIR)cpuid.c $(SRC_DIR)apic.c $(SRC_DIR)cpuid_asm.c $(SRC_DIR)uarch.c
 	HEADERS += $(COMMON_HDR) $(SRC_DIR)cpuid.h $(SRC_DIR)apic.h $(SRC_DIR)cpuid_asm.h $(SRC_DIR)uarch.h
@@ -80,7 +87,11 @@
 	$(CC) $(CFLAGS) $(SANITY_FLAGS) -c -mavx512f -pthread $(SRC_DIR)freq/freq_avx512.c -o $@
 
 $(OUTPUT): Makefile $(SOURCE) $(HEADERS)
+ifeq ($(GIT_VERSION),"")
 	$(CC) $(CFLAGS) $(SANITY_FLAGS) $(SOURCE) -o $(OUTPUT)
+else
+	$(CC) $(CFLAGS) $(SANITY_FLAGS) -DGIT_FULL_VERSION=\"$(GIT_VERSION)\" $(SOURCE) -o $(OUTPUT)
+endif
 
 run: $(OUTPUT)
 	./$(OUTPUT)

=== debian/changelog ===
cpufetch (1.04-1) unstable; urgency=medium

  * New upstream version 1.04.
  * Added preliminary support for RISC-V.
  * Significantly improved Allwiner SoC detection.
  * Added Rockchip SoC detection.

 -- Clay Stan <claystan97@gmail.com>  Sat, 26 Aug 2023 23:27:54 +0800

## cpufetch 1.05

=== debian/changelog ===
cpufetch (1.05-2) unstable; urgency=medium

  * Enable RISC-V build.

 -- Clay Stan <claystan97@gmail.com>  Wed, 08 May 2024 09:25:12 +0800

cpufetch (1.05-1) unstable; urgency=medium

  * New upstream version 1.05.
  * [ARM] Improved peak performance computation.
  * [ARM] Improved Rockchip and Allwinner detection (thanks ThomasKaiser!).
  * [ARM] Added support for Google Tensor SoCs.
  * [ARM and x86] Added new uarchs.
  * [ARM and x86] Improved error reporting in the case of unknown uarchs.
  * [RISCV] Implemented support for multi-letter extensions.
  * [All] Fixed various bugs.

 -- Clay Stan <claystan97@gmail.com>  Mon, 19 Feb 2024 09:51:39 +0800

=== debian/control ===
--- 
+++ 
@@ -3,14 +3,14 @@
 Priority: optional
 Maintainer: Clay Stan <claystan97@gmail.com>
 Build-Depends: debhelper-compat (= 13)
-Standards-Version: 4.6.0.1
+Standards-Version: 4.6.2.0
 Homepage: https://github.com/Dr-Noob/cpufetch
 Vcs-Browser: https://salsa.debian.org/claystan/cpufetch
 Vcs-Git: https://salsa.debian.org/claystan/cpufetch.git
 Rules-Requires-Root: no
 
 Package: cpufetch
-Architecture: any
+Architecture: amd64 arm64 armel armhf i386 ppc64 ppc64el x32 riscv64
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: Simple yet fancy CPU architecture fetching tool
  Shows CPU Information with CPU manufacturer Logo

## cpufetch 1.06

=== Makefile ===
--- 
+++ 
@@ -13,17 +13,23 @@
 ifneq ($(OS),Windows_NT)
 	GIT_VERSION := "$(shell git describe --abbrev=4 --dirty --always --tags)"
 	arch := $(shell uname -m)
+	os := $(shell uname -s)
+
+	ifeq ($(os), Linux)
+		COMMON_SRC += $(SRC_COMMON)freq.c
+		COMMON_HDR += $(SRC_COMMON)freq.h
+	endif
+
 	ifeq ($(arch), $(filter $(arch), x86_64 amd64 i386 i486 i586 i686))
 		SRC_DIR=src/x86/
 		SOURCE += $(COMMON_SRC) $(SRC_DIR)cpuid.c $(SRC_DIR)apic.c $(SRC_DIR)cpuid_asm.c $(SRC_DIR)uarch.c
 		HEADERS += $(COMMON_HDR) $(SRC_DIR)cpuid.h $(SRC_DIR)apic.h $(SRC_DIR)cpuid_asm.h $(SRC_DIR)uarch.h $(SRC_DIR)freq/freq.h
 
-                os := $(shell uname -s)
-                ifeq ($(os), Linux)
+		ifeq ($(os), Linux)
 			SOURCE += $(SRC_DIR)freq/freq.c freq_nov.o freq_avx.o freq_avx512.o
 			HEADERS += $(SRC_DIR)freq/freq.h
 			CFLAGS += -pthread
-                endif
+		endif
 		CFLAGS += -DARCH_X86 -std=c99 -fstack-protector-all
 	else ifeq ($(arch), $(filter $(arch), ppc64le ppc64 ppcle ppc))
 		SRC_DIR=src/ppc/
@@ -32,20 +38,25 @@
 		CFLAGS += -DARCH_PPC -std=gnu99 -fstack-protector-all -Wno-language-extension-token
 	else ifeq ($(arch), $(filter $(arch), arm aarch64_be aarch64 arm64 armv8b armv8l armv7l armv6l))
 		SRC_DIR=src/arm/
-		SOURCE += $(COMMON_SRC) $(SRC_DIR)midr.c $(SRC_DIR)uarch.c $(SRC_COMMON)soc.c $(SRC_DIR)soc.c $(SRC_DIR)udev.c
-		HEADERS += $(COMMON_HDR) $(SRC_DIR)midr.h $(SRC_DIR)uarch.h  $(SRC_COMMON)soc.h $(SRC_DIR)soc.h $(SRC_DIR)udev.c $(SRC_DIR)socs.h
+		SOURCE += $(COMMON_SRC) $(SRC_DIR)midr.c $(SRC_DIR)uarch.c $(SRC_COMMON)soc.c $(SRC_DIR)soc.c $(SRC_COMMON)pci.c $(SRC_DIR)udev.c sve.o
+		HEADERS += $(COMMON_HDR) $(SRC_DIR)midr.h $(SRC_DIR)uarch.h  $(SRC_COMMON)soc.h $(SRC_DIR)soc.h $(SRC_COMMON)pci.h $(SRC_DIR)udev.c $(SRC_DIR)socs.h
 		CFLAGS += -DARCH_ARM -Wno-unused-parameter -std=c99 -fstack-protector-all
 
-		os := $(shell uname -s)
+		# Check if the compiler supports -march=armv8-a+sve. We will use it (if supported) to compile SVE detection code later
+		is_sve_flag_supported := $(shell $(CC) -march=armv8-a+sve -c $(SRC_DIR)sve.c -o sve_test.o 2> /dev/null && echo 'yes'; rm -f sve_test.o)
+		ifeq ($(is_sve_flag_supported), yes)
+			SVE_FLAGS += -march=armv8-a+sve
+		endif
+
 		ifeq ($(os), Darwin)
-			SOURCE += $(SRC_DIR)sysctl.c
-			HEADERS += $(SRC_DIR)sysctl.h
+			SOURCE += $(SRC_COMMON)sysctl.c
+			HEADERS += $(SRC_COMMON)sysctl.h
 		endif
-        else ifeq ($(arch), $(filter $(arch), riscv64 riscv32))
-                SRC_DIR=src/riscv/
-                SOURCE += $(COMMON_SRC) $(SRC_DIR)riscv.c $(SRC_DIR)uarch.c $(SRC_COMMON)soc.c $(SRC_DIR)soc.c $(SRC_DIR)udev.c
-                HEADERS += $(COMMON_HDR) $(SRC_DIR)riscv.h $(SRC_DIR)uarch.h $(SRC_COMMON)soc.h $(SRC_DIR)soc.h $(SRC_DIR)udev.h $(SRC_DIR)socs.h
-                CFLAGS += -DARCH_RISCV -Wno-unused-parameter -std=c99 -fstack-protector-all
+	else ifeq ($(arch), $(filter $(arch), riscv64 riscv32))
+		SRC_DIR=src/riscv/
+		SOURCE += $(COMMON_SRC) $(SRC_DIR)riscv.c $(SRC_DIR)uarch.c $(SRC_COMMON)soc.c $(SRC_DIR)soc.c $(SRC_DIR)udev.c
+		HEADERS += $(COMMON_HDR) $(SRC_DIR)riscv.h $(SRC_DIR)uarch.h $(SRC_COMMON)soc.h $(SRC_DIR)soc.h $(SRC_DIR)udev.h $(SRC_DIR)socs.h
+		CFLAGS += -DARCH_RISCV -Wno-unused-parameter -std=c99 -fstack-protector-all
 	else
 		# Error lines should not be tabulated because Makefile complains about it
 $(warning Unsupported arch detected: $(arch). See https://github.com/Dr-Noob/cpufetch#1-support)
@@ -86,6 +97,9 @@
 freq_avx512.o: Makefile $(SRC_DIR)freq/freq_avx512.c $(SRC_DIR)freq/freq_avx512.h $(SRC_DIR)freq/freq.h
 	$(CC) $(CFLAGS) $(SANITY_FLAGS) -c -mavx512f -pthread $(SRC_DIR)freq/freq_avx512.c -o $@
 
+sve.o: Makefile $(SRC_DIR)sve.c $(SRC_DIR)sve.h
+	$(CC) $(CFLAGS) $(SANITY_FLAGS) $(SVE_FLAGS) -c $(SRC_DIR)sve.c -o $@
+
 $(OUTPUT): Makefile $(SOURCE) $(HEADERS)
 ifeq ($(GIT_VERSION),"")
 	$(CC) $(CFLAGS) $(SANITY_FLAGS) $(SOURCE) -o $(OUTPUT)

=== debian/changelog ===
cpufetch (1.06-2) unstable; urgency=medium

  * Update build Architecture to any (Closes: #1031673).

 -- Clay Stan <claystan97@gmail.com>  Tue, 11 Mar 2025 16:53:01 +0800

cpufetch (1.06-1) unstable; urgency=medium

  * New upstream version 1.06.
  * [ARM] Added support for inferring the SoC from the uarch.
  * [ARM] Added support for inferring the SoC from PCI devices (#245).
  * [ARM] Added support for SVE detection (#259).
  * [X86] Significantly improved support for old x86 CPUs (#220).
  * [X86] Added support for Hygon CPUs (#244).
  * [ARM and X86] Added support for measuring max CPU frequency (#220).
  * [ARM and X86] Added --measure-max-freq option to manually trigger CPU max frequency measurement.
  * [All] Added support for NO_COLOR (#227).

 -- Clay Stan <claystan97@gmail.com>  Wed, 09 Oct 2024 10:34:24 +0800

cpufetch (1.05-3) unstable; urgency=medium

  * Refresh patch for build RISCV.

 -- Clay Stan <claystan97@gmail.com>  Wed, 08 May 2024 11:01:43 +0800

=== debian/control ===
--- 
+++ 
@@ -10,7 +10,7 @@
 Rules-Requires-Root: no
 
 Package: cpufetch
-Architecture: amd64 arm64 armel armhf i386 ppc64 ppc64el x32 riscv64
+Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: Simple yet fancy CPU architecture fetching tool
  Shows CPU Information with CPU manufacturer Logo

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/cpufetch-$1\.tar\.gz/ \
  https://github.com/Dr-Noob/cpufetch/tags \
 .*/v?(\d\S+)\.tar\.gz debian uupdate

## cpufetch 1.07

=== debian/changelog ===
cpufetch (1.07-2) unstable; urgency=medium

  * Fix the build on ppc64 (Closes: 1123864).

 -- Clay Stan <claystan97@gmail.com>  Wed, 21 Jan 2026 06:55:22 -0500

cpufetch (1.07-1) unstable; urgency=medium

  * [Apple] Implement fallback frequency calculation
  * [X86] Add old Intel and AMD CPUs
  * [X86] Fix 2 bugs in --accurate-pp
  * [ARM] Add (experimental) Windows on Arm support
  * [ARM] Add support for a lot of new SoCs
  * [ARM] Add automatic SoC inferring from device tree
  * [RISCV] Significantly improved support for RISC-V, specially uarch detection and multi-letter extension support.

 -- Clay Stan <claystan97@gmail.com>  Thu, 20 Nov 2025 14:47:32 +0800
